"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _rax = require("rax");

var _raxScrollview = _interopRequireDefault(require("rax-scrollview"));

var _raxText = _interopRequireDefault(require("rax-text"));

var _raxView = _interopRequireDefault(require("rax-view"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DEFAULT_HEIGHT = 480;

var Table =
/*#__PURE__*/
function (_Component) {
  _inherits(Table, _Component);

  function Table() {
    _classCallCheck(this, Table);

    return _possibleConstructorReturn(this, _getPrototypeOf(Table).apply(this, arguments));
  }

  _createClass(Table, [{
    key: "_renderCell",
    value: function _renderCell(cellData, col) {
      var width = col.width || this.props.columnWidth;
      var style = {};

      if (width) {
        style.width = width;
      } else {
        style.flex = 1;
      }

      return (0, _rax.createElement)(_raxView.default, {
        key: col.dataIndex,
        style: [styles.tableCell, style]
      }, (0, _rax.createElement)(_raxText.default, null, cellData));
    }
  }, {
    key: "_renderHeader",
    value: function _renderHeader() {
      var _this$props = this.props,
          columns = _this$props.columns,
          columnWidth = _this$props.columnWidth;
      return columns.map(function (col, index) {
        var width = col.width || columnWidth;
        var style = {};

        if (width) {
          style.width = width;
        } else {
          style.flex = 1;
        }

        return (0, _rax.createElement)(_raxView.default, {
          key: index,
          style: [styles.tableHeaderCell, style]
        }, (0, _rax.createElement)(_raxText.default, null, col.title));
      });
    }
  }, {
    key: "_renderRow",
    value: function _renderRow(rowData, index) {
      var _this$props2 = this.props,
          columns = _this$props2.columns,
          renderCell = _this$props2.renderCell;

      if (!renderCell) {
        renderCell = this._renderCell.bind(this);
      }

      return (0, _rax.createElement)(_raxView.default, {
        key: index,
        style: styles.tableRow
      }, columns.map(function (col) {
        return renderCell(rowData[col.dataIndex], col);
      }));
    }
  }, {
    key: "render",
    value: function render() {
      var _this = this;

      var _this$props3 = this.props,
          width = _this$props3.width,
          height = _this$props3.height,
          style = _this$props3.style,
          dataSource = _this$props3.dataSource;
      return (0, _rax.createElement)(_raxScrollview.default, {
        style: [style, {
          width: width,
          height: height
        }],
        contentContainerStyle: [style, {
          width: width,
          height: height
        }],
        horizontal: true
      }, (0, _rax.createElement)(_raxView.default, {
        style: styles.tableBody
      }, (0, _rax.createElement)(_raxView.default, {
        style: styles.tableHeader
      }, this._renderHeader()), (0, _rax.createElement)(_raxScrollview.default, {
        style: styles.tableBody
      }, dataSource.map(function (rowData, index) {
        return _this._renderRow(rowData, index);
      }))));
    }
  }]);

  return Table;
}(_rax.Component);

_defineProperty(Table, "defaultProps", {
  columns: [],
  dataSource: [],
  columnWidth: undefined,
  renderCell: undefined,
  height: DEFAULT_HEIGHT
});

var styles = {
  tableHeader: {
    flexDirection: 'row'
  },
  tableHeaderCell: {
    minHeight: 30,
    backgroundColor: '#efefef',
    borderRightWidth: 1,
    borderRightColor: '#dfdfdf',
    alignItems: 'center',
    justifyContent: 'center'
  },
  tableBody: {
    flex: 1
  },
  tableRow: {
    flexDirection: 'row',
    backgroundColor: '#fbfbfb',
    borderBottomWidth: 1,
    borderBottomColor: '#dfdfdf'
  },
  tableCell: {
    minHeight: 50,
    backgroundColor: 'transparent',
    borderRightWidth: 1,
    borderRightColor: '#dfdfdf',
    alignItems: 'center',
    justifyContent: 'center'
  }
};
var _default = Table;
exports.default = _default;
module.exports = exports["default"];